unit Unit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Grids, ZipList, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Panel1     : TPanel;
    Button1    : TButton;
    OpenDialog1: TOpenDialog;
    Button2    : TButton;
    Label1     : TLabel;
    Label2     : TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    ListOfZips : TZipList;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
     ListOfZips := TZipList.Create (Self);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     ListOfZips.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
Var FillAll : Integer;
Begin
     OpenDialog1.Execute; {Execute Openfile Dialog}

     With ListOfZips Do
       Begin
         FileName := OpenDialog1.Filename; {Fills the filename variable}

         StringGrid1.RowCount := GetCount; {Add as many rows as items in zip}

         For FillAll := 0 to (GetCount - 1) Do {Do a for loop to scan all items in zip}
           Begin
             If HasDirectory (FillAll) Then {If item has a directory stored in zip}
               StringGrid1.Cells[0, FillAll] := '*' + GetName (FillAll) {Add a '*' when item has directory}
             Else
               StringGrid1.Cells[0, FillAll] := GetName (FillAll); {Only name if no dir struct}

             StringGrid1.Cells[1, FillAll] := IntToStr (GetUSize (FillAll)); {Shows uncompressed size}
             StringGrid1.Cells[2, FillAll] := IntToStr (GetCSize (FillAll)); {Shows compressed size}
             StringGrid1.Cells[3, FillAll] := GetGain (FillAll); {Shows Compressed ratio}
             StringGrid1.Cells[4, FillAll] := GetMethod (FillAll); {Shows Compressed ratio}
             StringGrid1.Cells[5, FillAll] := GetCRC32 (FillAll); {Shows the 32bit CRC}
             StringGrid1.Cells[6, FillAll] := GetDate (FillAll);
             StringGrid1.Cells[7, FillAll] := GetTime (FillAll);
           End;
       End;
End;

procedure TForm1.Button2Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
begin
     Label2.Caption := ListOfZips.GetDirectory (Row);
end;

end.
